system jenkins pipeline
Change-Id: Id6d0f202b1aa39844519271a34369a147fa6fcea
Signed-off-by: Mike Marchetti <mmarchetti@sandvine.com>
diff --git a/Jenkinsfile b/Jenkinsfile
new file mode 100644
index 0000000..26ae7d8
--- /dev/null
+++ b/Jenkinsfile
@@ -0,0 +1,19 @@
+// input parameters:
+// boolean: BUILD_FROM_SOURCE
+// string: TAG_OR_BRANCH
+
+node {
+ stage("Checkout") {
+ git branch: 'systest', url: 'https://osm.etsi.org/gerrit/osm/devops'
+ }
+ stage("Build") {
+ from_source = ''
+ if ( params.BUILD_FROM_SOURCE )
+ {
+ from_source = '--source'
+ }
+ container_name=params.TAG_OR_BRANCH.replaceAll(/\./,"")
+
+ sh "jenkins/host/start_build system --build-container osm-${container_name} -b ${params.TAG_OR_BRANCH} ${from_source}"
+ }
+}
diff --git a/installers/install_osm.sh b/installers/install_osm.sh
index f739724..5c9b2eb 100755
--- a/installers/install_osm.sh
+++ b/installers/install_osm.sh
@@ -129,6 +129,32 @@
echo
}
+function so_is_up(){
+ SO_IP=$1
+ time=0
+ step=5
+ timelength=300
+ while [ $time -le $timelength ]
+ do
+ curl -k https://$SO_IP:8008/api/operational/vcs/info \
+ --header 'accept: application/vnd.yang.data+json' \
+ --header 'authorization: Basic YWRtaW46YWRtaW4=' \
+ --header 'cache-control: no-cache' \
+ --header 'content-type: application/vnd.yang.data+json' &> /dev/null
+ RET=$?
+ if [ "$RET" == 0 ]; then
+ break
+ fi
+ sleep $step
+ echo -n "."
+ time=$((time+step))
+ done
+ if [ "$RET" != 0 ]; then
+ FATAL "OSM Failed to startup"
+ fi
+ echo
+}
+
#Configure VCA, SO and RO with the initial configuration:
# RO -> tenant:osm, logs to be sent to SO
# VCA -> juju-password
@@ -141,7 +167,9 @@
echo -e " Configuring RO"
lxc exec RO -- sed -i -e "s/^\#\?log_socket_host:.*/log_socket_host: $SO_CONTAINER_IP/g" /etc/osm/openmanod.cfg
lxc exec RO -- service osm-ro restart
+
time=0; step=2; timelength=20; while [ $time -le $timelength ]; do sleep $step; echo -n "."; time=$((time+step)); done; echo
+
lxc exec RO -- openmano tenant-delete -f osm >/dev/null
RO_TENANT_ID=`lxc exec RO -- openmano tenant-create osm |awk '{print $1}'`
@@ -153,8 +181,17 @@
echo -e " Configuring SO"
sudo route add -host $JUJU_CONTROLLER_IP gw $VCA_CONTAINER_IP
sudo sed -i "$ i route add -host $JUJU_CONTROLLER_IP gw $VCA_CONTAINER_IP" /etc/rc.local
- lxc exec SO-ub -- nohup sudo -b -H /usr/rift/rift-shell -r -i /usr/rift -a /usr/rift/.artifacts -- ./demos/launchpad.py --use-xml-mode &
- time=0; step=30; timelength=300; while [ $time -le $timelength ]; do sleep $step; echo -n "."; time=$((time+step)); done; echo
+ lxc exec SO-ub -- systemctl restart launchpad
+
+ so_is_up $SO_CONTAINER_IP
+
+ #delete existing config agent (could be there on reconfigure)
+ curl -k --request DELETE \
+ --url https://$SO_CONTAINER_IP:8008/api/config/config-agent/account/osmjuju \
+ --header 'accept: application/vnd.yang.data+json' \
+ --header 'authorization: Basic YWRtaW46YWRtaW4=' \
+ --header 'cache-control: no-cache' \
+ --header 'content-type: application/vnd.yang.data+json'
curl -k --request POST \
--url https://$SO_CONTAINER_IP:8008/api/config/config-agent \
diff --git a/jenkins/host/start_build b/jenkins/host/start_build
index ecb8ee5..02bfcc2 100755
--- a/jenkins/host/start_build
+++ b/jenkins/host/start_build
@@ -34,6 +34,7 @@
shift
[ $# -lt 1 ] && FATAL "missing container name with option --build-container"
export OSM_BUILD_CONTAINER=$1
+ shift
fi
if ! container_exists $OSM_BUILD_CONTAINER; then